// List Shared Sections
// by Cesar Cerrudo

#include "stdafx.h"
#include <windows.h>
#include <stdio.h>

typedef struct _LSA_UNICODE_STRING {  
	USHORT Length;  
	USHORT MaximumLength; 
	PWSTR Buffer;
} UNICODE_STRING;

typedef struct _OBJDIR_INFORMATION {
  UNICODE_STRING          ObjectName;
  UNICODE_STRING          ObjectTypeName;
  BYTE                    Data[1];
} OBJDIR_INFORMATION;

typedef struct _OBJECT_ATTRIBUTES {
    ULONG Length;
    HANDLE RootDirectory;
    UNICODE_STRING *ObjectName;
    ULONG Attributes;
    PVOID SecurityDescriptor;        
    PVOID SecurityQualityOfService;  
} OBJECT_ATTRIBUTES;

#define InitializeObjectAttributes( p, n, a, r, s ) { \
    (p)->Length = sizeof( OBJECT_ATTRIBUTES );          \
    (p)->RootDirectory = r;                             \
    (p)->Attributes = a;                                \
    (p)->ObjectName = n;                                \
    (p)->SecurityDescriptor = s;                        \
    (p)->SecurityQualityOfService = NULL;               \
    }


#define InitializeUnicodeStr(p,s) { \
	(p)->Length=wcslen(s)*2;			\
	(p)->MaximumLength =wcslen(s)*2+2;\
	(p)->Buffer =s;					\
    }

typedef DWORD (WINAPI* NTQUERYDIRECTORYOBJECT)( HANDLE, OBJDIR_INFORMATION*, DWORD, DWORD ,DWORD,DWORD*,DWORD* );
NTQUERYDIRECTORYOBJECT NtQueryDirectoryObject;

typedef DWORD (WINAPI* NTOPENDIRECTORYOBJECT)( HANDLE *, DWORD,OBJECT_ATTRIBUTES* );
NTOPENDIRECTORYOBJECT  NtOpenDirectoryObject;

int main(int argc, char* argv[])
{

  OBJDIR_INFORMATION *ssinfo  =(OBJDIR_INFORMATION* ) HeapAlloc(GetProcessHeap(), 0, 0x800);

  HANDLE hFile;
  HMODULE hNtdll ;
  OBJECT_ATTRIBUTES obj;
  WCHAR  uString[50];
  UNICODE_STRING str;
  DWORD i=0,a,b=0;

  hNtdll = LoadLibrary("ntdll.dll");    

  NtQueryDirectoryObject = (NTQUERYDIRECTORYOBJECT )GetProcAddress(hNtdll,"NtQueryDirectoryObject");
  NtOpenDirectoryObject = (NTOPENDIRECTORYOBJECT )GetProcAddress(hNtdll,"NtOpenDirectoryObject");
  
  wcscpy(uString,L"\\BaseNamedObjects");

  InitializeUnicodeStr(&str,uString);
  InitializeObjectAttributes (&obj, &str, 0, 0, 00);


  while((NtOpenDirectoryObject(&hFile,0x20001,&obj)==0) | (i<6)){ //Dump at least 5 TS sessions
		
	  if (i==0)
			printf("\nListing local Shared Sections...\n\n");
		else
			printf("\nListing TS Session #%u Shared Sections...\n\n",i);

		if (NtQueryDirectoryObject(hFile,ssinfo,0x800,TRUE,TRUE,&b,&a)==0){
			while (NtQueryDirectoryObject(hFile,ssinfo,0x800,TRUE,FALSE,&b,&a)==0)
				if (!wcscmp(ssinfo->ObjectTypeName.Buffer ,L"Section"))
					printf("%S\\%S \n",uString,ssinfo->ObjectName.Buffer );
		} 
		
		i++;
		swprintf(uString,L"\\Sessions\\%u\\BaseNamedObjects",i);

		InitializeUnicodeStr(&str,uString);
		InitializeObjectAttributes (&obj, &str, 0, 0, 00);
  }

  
  return 0;

}


